
_interrupt:

;7segdisplay.mbas,199 :: 		dim dummy as byte
;7segdisplay.mbas,202 :: 		if interrupt_on_change_occured then
	BTFSS      IOCIF_bit+0, BitPos(IOCIF_bit+0)
	GOTO       L__interrupt2
;7segdisplay.mbas,203 :: 		if INPUT_ENABLE_PORT = 0 then   ' falling edge
	BTFSC      RA5_bit+0, BitPos(RA5_bit+0)
	GOTO       L__interrupt5
;7segdisplay.mbas,204 :: 		INT_interrupt_enable = true
	BSF        INTE_bit+0, BitPos(INTE_bit+0)
	GOTO       L__interrupt6
;7segdisplay.mbas,205 :: 		else                            ' rising edge
L__interrupt5:
;7segdisplay.mbas,206 :: 		recieve_buf = data_register
	MOVF       _data_register+0, 0
	MOVWF      _recieve_buf+0
;7segdisplay.mbas,207 :: 		data_full = true
	MOVLW      255
	MOVWF      _data_full+0
;7segdisplay.mbas,208 :: 		INT_interrupt_enable = false
	BCF        INTE_bit+0, BitPos(INTE_bit+0)
;7segdisplay.mbas,209 :: 		end if
L__interrupt6:
;7segdisplay.mbas,210 :: 		ENABLE_interrupt_occured = false
	BCF        IOCAF5_bit+0, BitPos(IOCAF5_bit+0)
;7segdisplay.mbas,211 :: 		interrupt_on_change_occured = false
	BCF        IOCIF_bit+0, BitPos(IOCIF_bit+0)
L__interrupt2:
;7segdisplay.mbas,215 :: 		if CLK_interrupt_occured then
	BTFSS      INTF_bit+0, BitPos(INTF_bit+0)
	GOTO       L__interrupt8
;7segdisplay.mbas,216 :: 		data_register = data_register << 1
	LSLF       _data_register+0, 1
;7segdisplay.mbas,217 :: 		data_register = data_register + INPUT_DATA_PORT
	CLRF       R0
	BTFSC      RC6_bit+0, BitPos(RC6_bit+0)
	INCF       R0, 1
	MOVF       R0, 0
	ADDWF      _data_register+0, 1
;7segdisplay.mbas,219 :: 		CLK_interrupt_occured = false
	BCF        INTF_bit+0, BitPos(INTF_bit+0)
L__interrupt8:
;7segdisplay.mbas,221 :: 		end sub
L_end_interrupt:
L__interrupt303:
	RETFIE     %s
; end of _interrupt

_decode_pattern:

;7segdisplay.mbas,234 :: 		dim dp          as boolean )
;7segdisplay.mbas,236 :: 		if dp then
	MOVF       FARG_decode_pattern_dp+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__decode_pattern12
;7segdisplay.mbas,237 :: 		segRB = bit_pattern or  %00010000
	MOVLW      16
	IORWF       FARG_decode_pattern_bit_pattern+0, 0
	MOVWF      _segRB+0
	GOTO       L__decode_pattern13
;7segdisplay.mbas,238 :: 		else
L__decode_pattern12:
;7segdisplay.mbas,239 :: 		segRB = bit_pattern and %10100000
	MOVLW      160
	ANDWF      FARG_decode_pattern_bit_pattern+0, 0
	MOVWF      _segRB+0
;7segdisplay.mbas,240 :: 		end if
L__decode_pattern13:
;7segdisplay.mbas,241 :: 		segRC = bit_pattern
	MOVF       FARG_decode_pattern_bit_pattern+0, 0
	MOVWF      _segRC+0
;7segdisplay.mbas,243 :: 		LATB = segRB
	MOVF       _segRB+0, 0
	MOVWF      LATB+0
;7segdisplay.mbas,244 :: 		LATC = segRC
	MOVF       FARG_decode_pattern_bit_pattern+0, 0
	MOVWF      LATC+0
;7segdisplay.mbas,245 :: 		end sub
L_end_decode_pattern:
	RETURN
; end of _decode_pattern

_decode_char_max7219:

;7segdisplay.mbas,250 :: 		sub function decode_char_max7219(dim char_code as byte) as byte
;7segdisplay.mbas,252 :: 		case MAX7219_Digit_0     result = Digit_0
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      126
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721918
	MOVLW      159
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721918:
;7segdisplay.mbas,253 :: 		case MAX7219_Digit_1     result = Digit_1
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      48
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721921
	MOVLW      12
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721921:
;7segdisplay.mbas,254 :: 		case MAX7219_Digit_2     result = Digit_2
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      109
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721924
	MOVLW      59
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721924:
;7segdisplay.mbas,255 :: 		case MAX7219_Digit_3     result = Digit_3
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      121
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721927
	MOVLW      62
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721927:
;7segdisplay.mbas,256 :: 		case MAX7219_Digit_4     result = Digit_4
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      51
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721930
	MOVLW      172
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721930:
;7segdisplay.mbas,257 :: 		case MAX7219_Digit_5     result = Digit_5
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      91
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721933
	MOVLW      182
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721933:
;7segdisplay.mbas,258 :: 		case MAX7219_Digit_6     result = Digit_6
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      95
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721936
	MOVLW      183
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721936:
;7segdisplay.mbas,259 :: 		case MAX7219_Digit_7     result = Digit_7
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      112
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721939
	MOVLW      28
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721939:
;7segdisplay.mbas,260 :: 		case MAX7219_Digit_8     result = Digit_8
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      127
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721942
	MOVLW      191
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721942:
;7segdisplay.mbas,261 :: 		case MAX7219_Digit_9     result = Digit_9
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      123
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721945
	MOVLW      190
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721945:
;7segdisplay.mbas,262 :: 		case MAX7219_Digit_E     result = Digit_E
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      79
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721948
	MOVLW      179
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721948:
;7segdisplay.mbas,263 :: 		case MAX7219_Digit_F     result = Digit_F
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      71
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721951
	MOVLW      177
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721951:
;7segdisplay.mbas,264 :: 		case MAX7219_Digit_U     result = Digit_U
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      62
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721954
	MOVLW      143
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721954:
;7segdisplay.mbas,265 :: 		case MAX7219_Digit_u_    result = Digit_u_
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      28
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721957
	MOVLW      7
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721957:
;7segdisplay.mbas,266 :: 		case MAX7219_Digit_L     result = Digit_L
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      14
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721960
	MOVLW      131
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721960:
;7segdisplay.mbas,267 :: 		case MAX7219_Digit_C     result = Digit_C
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      78
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721963
	MOVLW      147
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721963:
;7segdisplay.mbas,268 :: 		case MAX7219_Digit_P     result = Digit_P
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      103
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721966
	MOVLW      185
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721966:
;7segdisplay.mbas,269 :: 		case MAX7219_Digit_y     result = Digit_y
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      59
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721969
	MOVLW      174
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721969:
;7segdisplay.mbas,270 :: 		case MAX7219_Digit_A     result = Digit_A
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      119
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721972
	MOVLW      189
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721972:
;7segdisplay.mbas,271 :: 		case MAX7219_Digit_a_    result = Digit_a_
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      125
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721975
	MOVLW      63
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721975:
;7segdisplay.mbas,272 :: 		case MAX7219_Digit_r     result = Digit_r
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721978
	MOVLW      33
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721978:
;7segdisplay.mbas,273 :: 		case MAX7219_Digit_n     result = Digit_n
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      21
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721981
	MOVLW      37
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721981:
;7segdisplay.mbas,274 :: 		case MAX7219_Digit_d     result = Digit_d
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      61
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721984
	MOVLW      47
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721984:
;7segdisplay.mbas,275 :: 		case MAX7219_Digit_t     result = Digit_t
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      15
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721987
	MOVLW      163
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721987:
;7segdisplay.mbas,276 :: 		case MAX7219_Digit_G     result = Digit_G
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      94
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721990
	MOVLW      151
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721990:
;7segdisplay.mbas,277 :: 		case MAX7219_Digit_b     result = Digit_b
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      31
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721993
	MOVLW      167
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721993:
;7segdisplay.mbas,278 :: 		case MAX7219_Digit_i_    result = Digit_i_
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721996
	MOVLW      1
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721996:
;7segdisplay.mbas,279 :: 		case MAX7219_Digit_l_    result = Digit_l_
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max721999
	MOVLW      1
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max721999:
;7segdisplay.mbas,280 :: 		case MAX7219_Digit_NON   result = Digit_NON
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max7219102
	CLRF       R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max7219102:
;7segdisplay.mbas,281 :: 		case MAX7219_Digit_o     result = Digit_o
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      29
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max7219105
	MOVLW      39
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max7219105:
;7segdisplay.mbas,282 :: 		case MAX7219_Digit_h_    result = Digit_h_
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      23
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max7219108
	MOVLW      165
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max7219108:
;7segdisplay.mbas,283 :: 		case MAX7219_Digit_H     result = Digit_H
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      55
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max7219111
	MOVLW      173
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max7219111:
;7segdisplay.mbas,284 :: 		case MAX7219_Digit_c_    result = Digit_c_
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      13
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max7219114
	MOVLW      35
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max7219114:
;7segdisplay.mbas,285 :: 		case MAX7219_Digit_US    result = Digit_US
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max7219117
	MOVLW      2
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max7219117:
;7segdisplay.mbas,286 :: 		case MAX7219_Digit_MINUS result = Digit_MINUS
	MOVF       FARG_decode_char_max7219_char_code+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_max7219120
	MOVLW      32
	MOVWF      R1+0
	GOTO       L__decode_char_max721915
L__decode_char_max7219120:
;7segdisplay.mbas,287 :: 		case else result = Digit_NON
	CLRF       R1+0
L__decode_char_max721915:
;7segdisplay.mbas,289 :: 		end sub
	MOVF       R1+0, 0
	MOVWF      R0
L_end_decode_char_max7219:
	RETURN
; end of _decode_char_max7219

_decode_char_ascii:

;7segdisplay.mbas,294 :: 		sub function decode_char_ascii(dim char_code as byte) as byte
;7segdisplay.mbas,296 :: 		case "0"  result = Digit_0
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      48
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii125
	MOVLW      159
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii125:
;7segdisplay.mbas,297 :: 		case "1"  result = Digit_1
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      49
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii128
	MOVLW      12
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii128:
;7segdisplay.mbas,298 :: 		case "2"  result = Digit_2
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      50
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii131
	MOVLW      59
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii131:
;7segdisplay.mbas,299 :: 		case "3"  result = Digit_3
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      51
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii134
	MOVLW      62
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii134:
;7segdisplay.mbas,300 :: 		case "4"  result = Digit_4
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      52
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii137
	MOVLW      172
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii137:
;7segdisplay.mbas,301 :: 		case "5"  result = Digit_5
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      53
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii140
	MOVLW      182
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii140:
;7segdisplay.mbas,302 :: 		case "6"  result = Digit_6
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      54
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii143
	MOVLW      183
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii143:
;7segdisplay.mbas,303 :: 		case "7"  result = Digit_7
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      55
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii146
	MOVLW      28
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii146:
;7segdisplay.mbas,304 :: 		case "8"  result = Digit_8
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      56
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii149
	MOVLW      191
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii149:
;7segdisplay.mbas,305 :: 		case "9"  result = Digit_9
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      57
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii152
	MOVLW      190
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii152:
;7segdisplay.mbas,306 :: 		case "E"  result = Digit_E
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      69
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii155
	MOVLW      179
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii155:
;7segdisplay.mbas,307 :: 		case "F"  result = Digit_F
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      70
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii158
	MOVLW      177
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii158:
;7segdisplay.mbas,308 :: 		case "U"  result = Digit_U
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      85
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii161
	MOVLW      143
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii161:
;7segdisplay.mbas,309 :: 		case "u"  result = Digit_u_
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      117
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii164
	MOVLW      7
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii164:
;7segdisplay.mbas,310 :: 		case "L"  result = Digit_L
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      76
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii167
	MOVLW      131
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii167:
;7segdisplay.mbas,311 :: 		case "C"  result = Digit_C
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      67
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii170
	MOVLW      147
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii170:
;7segdisplay.mbas,312 :: 		case "P"  result = Digit_P
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      80
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii173
	MOVLW      185
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii173:
;7segdisplay.mbas,313 :: 		case "y"  result = Digit_y
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      121
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii176
	MOVLW      174
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii176:
;7segdisplay.mbas,314 :: 		case "A"  result = Digit_A
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      65
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii179
	MOVLW      189
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii179:
;7segdisplay.mbas,315 :: 		case "a"  result = Digit_a_
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      97
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii182
	MOVLW      63
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii182:
;7segdisplay.mbas,316 :: 		case "r"  result = Digit_r
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      114
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii185
	MOVLW      33
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii185:
;7segdisplay.mbas,317 :: 		case "n"  result = Digit_n
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      110
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii188
	MOVLW      37
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii188:
;7segdisplay.mbas,318 :: 		case "d"  result = Digit_d
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      100
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii191
	MOVLW      47
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii191:
;7segdisplay.mbas,319 :: 		case "t"  result = Digit_t
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      116
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii194
	MOVLW      163
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii194:
;7segdisplay.mbas,320 :: 		case "G"  result = Digit_G
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      71
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii197
	MOVLW      151
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii197:
;7segdisplay.mbas,321 :: 		case "b"  result = Digit_b
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      98
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii200
	MOVLW      167
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii200:
;7segdisplay.mbas,322 :: 		case "i"  result = Digit_i_
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      105
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii203
	MOVLW      1
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii203:
;7segdisplay.mbas,323 :: 		case "I"  result = Digit_I
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      73
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii206
	MOVLW      129
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii206:
;7segdisplay.mbas,324 :: 		case "l"  result = Digit_l_
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      108
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii209
	MOVLW      1
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii209:
;7segdisplay.mbas,325 :: 		case " "  result = Digit_NON
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      32
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii212
	CLRF       R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii212:
;7segdisplay.mbas,326 :: 		case "o"  result = Digit_o
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      111
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii215
	MOVLW      39
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii215:
;7segdisplay.mbas,327 :: 		case "h"  result = Digit_h_
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      104
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii218
	MOVLW      165
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii218:
;7segdisplay.mbas,328 :: 		case "H"  result = Digit_H
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      72
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii221
	MOVLW      173
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii221:
;7segdisplay.mbas,329 :: 		case "c"  result = Digit_c_
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      99
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii224
	MOVLW      35
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii224:
;7segdisplay.mbas,330 :: 		case "_"  result = Digit_US
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      95
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii227
	MOVLW      2
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii227:
;7segdisplay.mbas,331 :: 		case "-"  result = Digit_MINUS
	MOVF       FARG_decode_char_ascii_char_code+0, 0
	XORLW      45
	BTFSS      STATUS+0, 2
	GOTO       L__decode_char_ascii230
	MOVLW      32
	MOVWF      R1+0
	GOTO       L__decode_char_ascii122
L__decode_char_ascii230:
;7segdisplay.mbas,332 :: 		case else result = Digit_NON
	CLRF       R1+0
L__decode_char_ascii122:
;7segdisplay.mbas,334 :: 		end sub
	MOVF       R1+0, 0
	MOVWF      R0
L_end_decode_char_ascii:
	RETURN
; end of _decode_char_ascii

_rotate:

;7segdisplay.mbas,345 :: 		dim bit0 as byte
;7segdisplay.mbas,348 :: 		bit7 = (bitpattern and %00000100) << 5
	MOVLW      4
	ANDWF      FARG_rotate_bitpattern+0, 0
	MOVWF      R1
	MOVLW      5
	MOVWF      R0
	MOVF       R1, 0
	MOVWF      R7
	MOVF       R0, 0
L__rotate308:
	BTFSC      STATUS+0, 2
	GOTO       L__rotate309
	LSLF       R7, 1
	ADDLW      255
	GOTO       L__rotate308
L__rotate309:
;7segdisplay.mbas,349 :: 		bit2 = (bitpattern and %10000000) >> 5
	MOVLW      128
	ANDWF      FARG_rotate_bitpattern+0, 0
	MOVWF      R1
	MOVLW      5
	MOVWF      R0
	MOVF       R1, 0
	MOVWF      R6
	MOVF       R0, 0
L__rotate310:
	BTFSC      STATUS+0, 2
	GOTO       L__rotate311
	LSRF       R6, 1
	ADDLW      255
	GOTO       L__rotate310
L__rotate311:
;7segdisplay.mbas,351 :: 		bit4 = (bitpattern and %00000010) << 3
	MOVLW      2
	ANDWF      FARG_rotate_bitpattern+0, 0
	MOVWF      R1
	MOVF       R1, 0
	MOVWF      R5
	LSLF       R5, 1
	LSLF       R5, 1
	LSLF       R5, 1
;7segdisplay.mbas,352 :: 		bit1 = (bitpattern and %00010000) >> 3
	MOVLW      16
	ANDWF      FARG_rotate_bitpattern+0, 0
	MOVWF      R1
	MOVF       R1, 0
	MOVWF      R4
	LSRF       R4, 1
	LSRF       R4, 1
	LSRF       R4, 1
;7segdisplay.mbas,354 :: 		bit3 = (bitpattern and %00001000) >> 3
	MOVLW      8
	ANDWF      FARG_rotate_bitpattern+0, 0
	MOVWF      R1
	MOVF       R1, 0
	MOVWF      R3
	LSRF       R3, 1
	LSRF       R3, 1
	LSRF       R3, 1
;7segdisplay.mbas,355 :: 		bit0 = (bitpattern and %00000001) << 3
	MOVLW      1
	ANDWF      FARG_rotate_bitpattern+0, 0
	MOVWF      R2
	MOVF       R2, 0
	MOVWF      R1
	LSLF       R1, 1
	LSLF       R1, 1
	LSLF       R1, 1
;7segdisplay.mbas,357 :: 		result = (bitpattern and %01100000) or bit7 or bit4 or bit3 or bit2 or bit1 or bit0
	MOVLW      96
	ANDWF      FARG_rotate_bitpattern+0, 0
	MOVWF      R0
	MOVF       R7, 0
	IORWF       R0, 1
	MOVF       R5, 0
	IORWF       R0, 1
	MOVF       R3, 0
	IORWF       R0, 1
	MOVF       R6, 0
	IORWF       R0, 1
	MOVF       R4, 0
	IORWF       R0, 1
	MOVF       R1, 0
	IORWF       R0, 0
	MOVWF      R8+0
;7segdisplay.mbas,358 :: 		end sub
	MOVF       R8+0, 0
	MOVWF      R0
L_end_rotate:
	RETURN
; end of _rotate

_set_table:

;7segdisplay.mbas,364 :: 		dim index as byte
;7segdisplay.mbas,366 :: 		for index  = 0 to 127
	CLRF       set_table_index+0
L__set_table234:
;7segdisplay.mbas,368 :: 		case CODE_ASCII
	MOVF       FARG_set_table_code_type+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__set_table241
;7segdisplay.mbas,369 :: 		code_table[index] = decode_char_ascii(index)
	MOVLW      _code_table+0
	MOVWF      R0
	MOVLW      hi_addr(_code_table+0)
	MOVWF      R1
	MOVF       set_table_index+0, 0
	ADDWF      R0, 0
	MOVWF      FLOC__set_table+0
	MOVLW      0
	ADDWFC     R1, 0
	MOVWF      FLOC__set_table+1
	MOVF       set_table_index+0, 0
	MOVWF      FARG_decode_char_ascii_char_code+0
	CALL       _decode_char_ascii+0
	MOVF       FLOC__set_table+0, 0
	MOVWF      FSR1L
	MOVF       FLOC__set_table+1, 0
	MOVWF      FSR1H
	MOVF       R0, 0
	MOVWF      INDF1+0
	GOTO       L__set_table238
L__set_table241:
;7segdisplay.mbas,370 :: 		case CODE_MAX7219
	MOVF       FARG_set_table_code_type+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__set_table244
;7segdisplay.mbas,371 :: 		code_table[index] = decode_char_max7219(index)
	MOVLW      _code_table+0
	MOVWF      R0
	MOVLW      hi_addr(_code_table+0)
	MOVWF      R1
	MOVF       set_table_index+0, 0
	ADDWF      R0, 0
	MOVWF      FLOC__set_table+0
	MOVLW      0
	ADDWFC     R1, 0
	MOVWF      FLOC__set_table+1
	MOVF       set_table_index+0, 0
	MOVWF      FARG_decode_char_max7219_char_code+0
	CALL       _decode_char_max7219+0
	MOVF       FLOC__set_table+0, 0
	MOVWF      FSR1L
	MOVF       FLOC__set_table+1, 0
	MOVWF      FSR1H
	MOVF       R0, 0
	MOVWF      INDF1+0
	GOTO       L__set_table238
L__set_table244:
;7segdisplay.mbas,372 :: 		case CODE_ASCII_ROTATE
	MOVF       FARG_set_table_code_type+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__set_table247
;7segdisplay.mbas,373 :: 		code_table[index] = rotate(decode_char_ascii(index))
	MOVLW      _code_table+0
	MOVWF      R0
	MOVLW      hi_addr(_code_table+0)
	MOVWF      R1
	MOVF       set_table_index+0, 0
	ADDWF      R0, 0
	MOVWF      FLOC__set_table+0
	MOVLW      0
	ADDWFC     R1, 0
	MOVWF      FLOC__set_table+1
	MOVF       set_table_index+0, 0
	MOVWF      FARG_decode_char_ascii_char_code+0
	CALL       _decode_char_ascii+0
	MOVF       R0, 0
	MOVWF      FARG_rotate_bitpattern+0
	CALL       _rotate+0
	MOVF       FLOC__set_table+0, 0
	MOVWF      FSR1L
	MOVF       FLOC__set_table+1, 0
	MOVWF      FSR1H
	MOVF       R0, 0
	MOVWF      INDF1+0
	GOTO       L__set_table238
L__set_table247:
;7segdisplay.mbas,374 :: 		case CODE_MAX7219_ROTATE
	MOVF       FARG_set_table_code_type+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__set_table250
;7segdisplay.mbas,375 :: 		code_table[index] = rotate(decode_char_max7219(index))
	MOVLW      _code_table+0
	MOVWF      R0
	MOVLW      hi_addr(_code_table+0)
	MOVWF      R1
	MOVF       set_table_index+0, 0
	ADDWF      R0, 0
	MOVWF      FLOC__set_table+0
	MOVLW      0
	ADDWFC     R1, 0
	MOVWF      FLOC__set_table+1
	MOVF       set_table_index+0, 0
	MOVWF      FARG_decode_char_max7219_char_code+0
	CALL       _decode_char_max7219+0
	MOVF       R0, 0
	MOVWF      FARG_rotate_bitpattern+0
	CALL       _rotate+0
	MOVF       FLOC__set_table+0, 0
	MOVWF      FSR1L
	MOVF       FLOC__set_table+1, 0
	MOVWF      FSR1H
	MOVF       R0, 0
	MOVWF      INDF1+0
	GOTO       L__set_table238
L__set_table250:
L__set_table238:
;7segdisplay.mbas,377 :: 		next index
	MOVF       set_table_index+0, 0
	XORLW      127
	BTFSC      STATUS+0, 2
	GOTO       L__set_table237
	INCF       set_table_index+0, 1
	GOTO       L__set_table234
L__set_table237:
;7segdisplay.mbas,378 :: 		end sub
L_end_set_table:
	RETURN
; end of _set_table

_dipsw:

;7segdisplay.mbas,384 :: 		Dim sw_position As Byte
;7segdisplay.mbas,386 :: 		sw_position = 0
	CLRF       R2+0
;7segdisplay.mbas,387 :: 		If DIP_SW1_PORT = 0 Then
	BTFSC      RC5_bit+0, BitPos(RC5_bit+0)
	GOTO       L__dipsw253
;7segdisplay.mbas,388 :: 		sw_position = sw_position + 1
	INCF       R2+0, 1
L__dipsw253:
;7segdisplay.mbas,390 :: 		If DIP_SW2_PORT = 0 Then
	BTFSC      RA3_bit+0, BitPos(RA3_bit+0)
	GOTO       L__dipsw256
;7segdisplay.mbas,391 :: 		sw_position = sw_position + 2
	MOVLW      2
	ADDWF      R2+0, 1
L__dipsw256:
;7segdisplay.mbas,393 :: 		If DIP_SW3_PORT = 0 Then
	BTFSC      RA1_bit+0, BitPos(RA1_bit+0)
	GOTO       L__dipsw259
;7segdisplay.mbas,394 :: 		sw_position = sw_position + 4
	MOVLW      4
	ADDWF      R2+0, 1
L__dipsw259:
;7segdisplay.mbas,396 :: 		If DIP_SW4_PORT = 0 Then
	BTFSC      RA0_bit+0, BitPos(RA0_bit+0)
	GOTO       L__dipsw262
;7segdisplay.mbas,397 :: 		sw_position = sw_position + 8
	MOVLW      8
	ADDWF      R2+0, 1
L__dipsw262:
;7segdisplay.mbas,400 :: 		result = sw_position
	MOVF       R2+0, 0
	MOVWF      R1+0
;7segdisplay.mbas,401 :: 		end sub
	MOVF       R1+0, 0
	MOVWF      R0
L_end_dipsw:
	RETURN
; end of _dipsw

_send_spi:

;7segdisplay.mbas,406 :: 		sub procedure send_spi( dim out_spi_data as byte )
;7segdisplay.mbas,407 :: 		OUTPUT_ENABLE_PORT = 0
	BCF        LATA4_bit+0, BitPos(LATA4_bit+0)
;7segdisplay.mbas,408 :: 		delay_us(1)
	NOP
	NOP
	NOP
	NOP
;7segdisplay.mbas,409 :: 		SSP1BUF = out_spi_data
	MOVF       FARG_send_spi_out_spi_data+0, 0
	MOVWF      SSP1BUF+0
;7segdisplay.mbas,410 :: 		while( PIR1.SSP1IF = 0)
L__send_spi266:
	BTFSS      PIR1+0, 3
	GOTO       L__send_spi266
;7segdisplay.mbas,412 :: 		PIR1.SSP1IF = 0
	BCF        PIR1+0, 3
;7segdisplay.mbas,413 :: 		delay_us(8)
	MOVLW      10
	MOVWF      R13
L__send_spi270:
	DECFSZ     R13, 1
	GOTO       L__send_spi270
	NOP
;7segdisplay.mbas,414 :: 		OUTPUT_ENABLE_PORT = 1
	BSF        LATA4_bit+0, BitPos(LATA4_bit+0)
;7segdisplay.mbas,415 :: 		delay_us(15)
	MOVLW      19
	MOVWF      R13
L__send_spi271:
	DECFSZ     R13, 1
	GOTO       L__send_spi271
	NOP
	NOP
;7segdisplay.mbas,416 :: 		end sub
L_end_send_spi:
	RETURN
; end of _send_spi

_main:

;7segdisplay.mbas,428 :: 		dim tmp_data        as byte
;7segdisplay.mbas,430 :: 		OSCCON.IRCF0 = 1     ' 16MHz
	BSF        OSCCON+0, 3
;7segdisplay.mbas,431 :: 		OSCCON.IRCF1 = 1
	BSF        OSCCON+0, 4
;7segdisplay.mbas,432 :: 		OSCCON.IRCF2 = 1
	BSF        OSCCON+0, 5
;7segdisplay.mbas,433 :: 		OSCCON.IRCF3 = 1
	BSF        OSCCON+0, 6
;7segdisplay.mbas,435 :: 		LED_SEGA_TRIS  = PORT_OUTPUT
	BCF        TRISC4_bit+0, BitPos(TRISC4_bit+0)
;7segdisplay.mbas,436 :: 		LED_SEGB_TRIS  = PORT_OUTPUT
	BCF        TRISC3_bit+0, BitPos(TRISC3_bit+0)
;7segdisplay.mbas,437 :: 		LED_SEGC_TRIS  = PORT_OUTPUT
	BCF        TRISC2_bit+0, BitPos(TRISC2_bit+0)
;7segdisplay.mbas,438 :: 		LED_SEGD_TRIS  = PORT_OUTPUT
	BCF        TRISC1_bit+0, BitPos(TRISC1_bit+0)
;7segdisplay.mbas,439 :: 		LED_SEGE_TRIS  = PORT_OUTPUT
	BCF        TRISC0_bit+0, BitPos(TRISC0_bit+0)
;7segdisplay.mbas,440 :: 		LED_SEGF_TRIS  = PORT_OUTPUT
	BCF        TRISB7_bit+0, BitPos(TRISB7_bit+0)
;7segdisplay.mbas,441 :: 		LED_SEGG_TRIS  = PORT_OUTPUT
	BCF        TRISB5_bit+0, BitPos(TRISB5_bit+0)
;7segdisplay.mbas,442 :: 		LED_SEGDP_TRIS = PORT_OUTPUT
	BCF        TRISB4_bit+0, BitPos(TRISB4_bit+0)
;7segdisplay.mbas,444 :: 		LED_SEGA_PORT  = 0
	BCF        LATC4_bit+0, BitPos(LATC4_bit+0)
;7segdisplay.mbas,445 :: 		LED_SEGB_PORT  = 0
	BCF        LATC3_bit+0, BitPos(LATC3_bit+0)
;7segdisplay.mbas,446 :: 		LED_SEGC_PORT  = 0
	BCF        LATC2_bit+0, BitPos(LATC2_bit+0)
;7segdisplay.mbas,447 :: 		LED_SEGD_PORT  = 0
	BCF        LATC1_bit+0, BitPos(LATC1_bit+0)
;7segdisplay.mbas,448 :: 		LED_SEGE_PORT  = 0
	BCF        LATC0_bit+0, BitPos(LATC0_bit+0)
;7segdisplay.mbas,449 :: 		LED_SEGF_PORT  = 0
	BCF        LATB7_bit+0, BitPos(LATB7_bit+0)
;7segdisplay.mbas,450 :: 		LED_SEGG_PORT  = 0
	BCF        LATB5_bit+0, BitPos(LATB5_bit+0)
;7segdisplay.mbas,451 :: 		LED_SEGDP_PORT = 0
	BCF        LATB4_bit+0, BitPos(LATB4_bit+0)
;7segdisplay.mbas,453 :: 		segRB = 0
	CLRF       _segRB+0
;7segdisplay.mbas,454 :: 		segRC = 0
	CLRF       _segRC+0
;7segdisplay.mbas,456 :: 		DIP_SW1_TRIS = PORT_INPUT
	BSF        TRISC5_bit+0, BitPos(TRISC5_bit+0)
;7segdisplay.mbas,457 :: 		DIP_SW2_TRIS = PORT_INPUT
	BSF        TRISA3_bit+0, BitPos(TRISA3_bit+0)
;7segdisplay.mbas,458 :: 		DIP_SW3_TRIS = PORT_INPUT
	BSF        TRISA1_bit+0, BitPos(TRISA1_bit+0)
;7segdisplay.mbas,459 :: 		DIP_SW4_TRIS = PORT_INPUT
	BSF        TRISA0_bit+0, BitPos(TRISA0_bit+0)
;7segdisplay.mbas,461 :: 		INPUT_CLK_TRIS     = PORT_INPUT
	BSF        TRISA2_bit+0, BitPos(TRISA2_bit+0)
;7segdisplay.mbas,462 :: 		INPUT_DATA_TRIS    = PORT_INPUT
	BSF        TRISC6_bit+0, BitPos(TRISC6_bit+0)
;7segdisplay.mbas,463 :: 		INPUT_ENABLE_TRIS  = PORT_INPUT
	BSF        TRISA5_bit+0, BitPos(TRISA5_bit+0)
;7segdisplay.mbas,464 :: 		OUTPUT_CLK_TRIS    = PORT_OUTPUT
	BCF        TRISB6_bit+0, BitPos(TRISB6_bit+0)
;7segdisplay.mbas,465 :: 		OUTPUT_DATA_TRIS   = PORT_OUTPUT
	BCF        TRISC7_bit+0, BitPos(TRISC7_bit+0)
;7segdisplay.mbas,466 :: 		OUTPUT_ENABLE_TRIS = PORT_OUTPUT
	BCF        TRISA4_bit+0, BitPos(TRISA4_bit+0)
;7segdisplay.mbas,468 :: 		ANSELA = 0x0  ' PORT A Digital I/O
	CLRF       ANSELA+0
;7segdisplay.mbas,469 :: 		ANSELC = 0x0  ' PORT C Digital I/O
	CLRF       ANSELC+0
;7segdisplay.mbas,472 :: 		Timer2_interrupt_enable    = FALSE
	BCF        TMR2IE_bit+0, BitPos(TMR2IE_bit+0)
;7segdisplay.mbas,473 :: 		Timer2_enable              = TRUE
	BSF        TMR2ON_bit+0, BitPos(TMR2ON_bit+0)
;7segdisplay.mbas,474 :: 		Timer2_period_register     = 39 ' 39 = 10usec
	MOVLW      39
	MOVWF      PR2+0
;7segdisplay.mbas,475 :: 		Timer2_prescale_bit0       = 0   ' prescale is 1:1
	BCF        T2CKPS0_bit+0, BitPos(T2CKPS0_bit+0)
;7segdisplay.mbas,476 :: 		Timer2_prescale_bit1       = 0
	BCF        T2CKPS1_bit+0, BitPos(T2CKPS1_bit+0)
;7segdisplay.mbas,479 :: 		INT_interrupt_rising_edge = true
	BSF        INTEDG_bit+0, BitPos(INTEDG_bit+0)
;7segdisplay.mbas,480 :: 		INT_interrupt_enable      = true
	BSF        INTE_bit+0, BitPos(INTE_bit+0)
;7segdisplay.mbas,483 :: 		IOCAP = 0
	CLRF       IOCAP+0
;7segdisplay.mbas,484 :: 		IOCAN = 0
	CLRF       IOCAN+0
;7segdisplay.mbas,485 :: 		IOCBP = 0
	CLRF       IOCBP+0
;7segdisplay.mbas,486 :: 		IOCBN = 0
	CLRF       IOCBN+0
;7segdisplay.mbas,488 :: 		interrupt_on_change_enable     = true
	BSF        IOCIE_bit+0, BitPos(IOCIE_bit+0)
;7segdisplay.mbas,489 :: 		ENABLE_positive_edge_interrupt = true
	BSF        IOCAP5_bit+0, BitPos(IOCAP5_bit+0)
;7segdisplay.mbas,490 :: 		ENABLE_negative_edge_interrupt = true
	BSF        IOCAN5_bit+0, BitPos(IOCAN5_bit+0)
;7segdisplay.mbas,493 :: 		SSP1CON1.SSPM3 = 0  ' Msater mode CLOCK TMR2 output/2
	BCF        SSP1CON1+0, 3
;7segdisplay.mbas,494 :: 		SSP1CON1.SSPM2 = 0
	BCF        SSP1CON1+0, 2
;7segdisplay.mbas,495 :: 		SSP1CON1.SSPM1 = 1
	BSF        SSP1CON1+0, 1
;7segdisplay.mbas,496 :: 		SSP1CON1.SSPM0 = 1
	BSF        SSP1CON1+0, 0
;7segdisplay.mbas,497 :: 		SSP1CON1.CKP = 1 ' Idle state for clock is a low level
	BSF        SSP1CON1+0, 4
;7segdisplay.mbas,498 :: 		SSP1STAT.CKE = 0
	BCF        SSP1STAT+0, 6
;7segdisplay.mbas,499 :: 		SSP1CON1.SSPEN = 1 ' enable SPI
	BSF        SSP1CON1+0, 5
;7segdisplay.mbas,500 :: 		SSP1IE_bit = false
	BCF        SSP1IE_bit+0, BitPos(SSP1IE_bit+0)
;7segdisplay.mbas,502 :: 		data_full = false
	CLRF       _data_full+0
;7segdisplay.mbas,503 :: 		set_table( CODE_ASCII )
	CLRF       FARG_set_table_code_type+0
	CALL       _set_table+0
;7segdisplay.mbas,504 :: 		delay_ms(100)
	MOVLW      3
	MOVWF      R11
	MOVLW      8
	MOVWF      R12
	MOVLW      119
	MOVWF      R13
L__main273:
	DECFSZ     R13, 1
	GOTO       L__main273
	DECFSZ     R12, 1
	GOTO       L__main273
	DECFSZ     R11, 1
	GOTO       L__main273
;7segdisplay.mbas,505 :: 		display_id = dipsw()
	CALL       _dipsw+0
	MOVF       R0, 0
	MOVWF      main_display_id+0
;7segdisplay.mbas,507 :: 		peripheral_interrupt_enable = true
	BSF        PEIE_bit+0, BitPos(PEIE_bit+0)
;7segdisplay.mbas,508 :: 		interrupt_enable = true
	BSF        GIE_bit+0, BitPos(GIE_bit+0)
;7segdisplay.mbas,510 :: 		while(true)
L__main275:
;7segdisplay.mbas,512 :: 		if data_full then
	MOVF       _data_full+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main280
;7segdisplay.mbas,513 :: 		data_full = false
	CLRF       _data_full+0
;7segdisplay.mbas,514 :: 		if recieve_buf >= 0x80 then
	MOVLW      128
	SUBWF      _recieve_buf+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L__main283
;7segdisplay.mbas,515 :: 		tmp_cmd = recieve_buf
	MOVF       _recieve_buf+0, 0
	MOVWF      main_tmp_cmd+0
;7segdisplay.mbas,516 :: 		send_spi( tmp_cmd  )
	MOVF       _recieve_buf+0, 0
	MOVWF      FARG_send_spi_out_spi_data+0
	CALL       _send_spi+0
;7segdisplay.mbas,517 :: 		continue
	GOTO       L__main275
;7segdisplay.mbas,518 :: 		else
L__main283:
;7segdisplay.mbas,519 :: 		tmp_data = recieve_buf
	MOVF       _recieve_buf+0, 0
	MOVWF      main_tmp_data+0
;7segdisplay.mbas,520 :: 		send_spi( tmp_data )
	MOVF       _recieve_buf+0, 0
	MOVWF      FARG_send_spi_out_spi_data+0
	CALL       _send_spi+0
;7segdisplay.mbas,523 :: 		data_display_id = tmp_cmd and DISPLAY_ID_MASK
	MOVLW      15
	ANDWF      main_tmp_cmd+0, 0
	MOVWF      R1
;7segdisplay.mbas,524 :: 		cmd_number      = tmp_cmd and CMD_TYPE_MASK
	MOVLW      112
	ANDWF      main_tmp_cmd+0, 0
	MOVWF      main_cmd_number+0
;7segdisplay.mbas,526 :: 		if data_display_id <> display_id then
	MOVF       R1, 0
	XORWF      main_display_id+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main286
;7segdisplay.mbas,527 :: 		my_data = false
	CLRF       main_my_data+0
	GOTO       L__main287
;7segdisplay.mbas,528 :: 		else
L__main286:
;7segdisplay.mbas,529 :: 		my_data = true
	MOVLW      255
	MOVWF      main_my_data+0
;7segdisplay.mbas,531 :: 		case CMD_NORMAL
	MOVF       main_cmd_number+0, 0
	XORLW      16
	BTFSS      STATUS+0, 2
	GOTO       L__main291
;7segdisplay.mbas,532 :: 		my_dp = false
	CLRF       main_my_dp+0
	GOTO       L__main288
L__main291:
;7segdisplay.mbas,533 :: 		case CMD_NORMAL_DP
	MOVF       main_cmd_number+0, 0
	XORLW      32
	BTFSS      STATUS+0, 2
	GOTO       L__main294
;7segdisplay.mbas,534 :: 		my_dp = true
	MOVLW      255
	MOVWF      main_my_dp+0
	GOTO       L__main288
L__main294:
L__main288:
;7segdisplay.mbas,536 :: 		end if
L__main287:
;7segdisplay.mbas,538 :: 		if my_data then
	MOVF       main_my_data+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main296
;7segdisplay.mbas,540 :: 		case CMD_CODE
	MOVF       main_cmd_number+0, 0
	XORLW      112
	BTFSS      STATUS+0, 2
	GOTO       L__main301
;7segdisplay.mbas,541 :: 		set_table( tmp_data )
	MOVF       main_tmp_data+0, 0
	MOVWF      FARG_set_table_code_type+0
	CALL       _set_table+0
	GOTO       L__main298
L__main301:
;7segdisplay.mbas,543 :: 		decode_pattern( code_table[ tmp_data ], my_dp )
	MOVLW      _code_table+0
	MOVWF      R0
	MOVLW      hi_addr(_code_table+0)
	MOVWF      R1
	MOVF       main_tmp_data+0, 0
	ADDWF      R0, 0
	MOVWF      FSR0L
	MOVLW      0
	ADDWFC     R1, 0
	MOVWF      FSR0H
	MOVF       INDF0+0, 0
	MOVWF      FARG_decode_pattern_bit_pattern+0
	MOVF       main_my_dp+0, 0
	MOVWF      FARG_decode_pattern_dp+0
	CALL       _decode_pattern+0
L__main298:
;7segdisplay.mbas,544 :: 		end select
L__main296:
;7segdisplay.mbas,545 :: 		end if
L__main280:
;7segdisplay.mbas,547 :: 		wend
	GOTO       L__main275
L_end_main:
	GOTO       $+0
; end of _main
